Python Template
---------------

The *python* project type generates an empty Python package according to standards used by RWS Datalab. This includes basic infrastructure to run tests and create useful documentation.

Project structure
"""""""""""""""""
The file structure of a Python project looks like:

.. code-block:: bash

   path/to/package/
   ├── .editorconfig
   ├── .gitignore
   ├── .gitlab-ci.yml
   ├── .pre-commit-config.yml
   ├── CHANGELOG.rst
   ├── CONTRIBUTING.rst
   ├── doc
   │   ├── conf.py
   │   ├── index.rst
   │   └── ...
   ├── LICENSE
   ├── MANIFEST.in
   ├── NOTICE
   ├── package
   │   ├── __init__.py
   │   ├── __version__.py
   │   └── example.py
   │   └── py.typed
   ├── pyproject.toml
   ├── README.rst
   └── setup.cfg
   └── tests
       ├── __init__.py
       └── test_package.py

* Code (existing or new) should be placed in ``path/to/package/package/`` (please choose a better name for your software! Keep the naming conventions for python modules and packages in mind: `PEP 8 <https://www.python.org/dev/peps/pep-0008/#package-and-module-names>`_ - Style Guide for Python Code and `PEP 423 <https://www.python.org/dev/peps/pep-0423/>`_ - Naming conventions and recipes related to packaging).
* Add documentation by editing ``path/to/package/doc/index.rst``
* Tests go in the ``path/to/package/tests/`` directory

.. include:: ../../../README.rst
  :start-after: .. begin-inclusion-usage-marker-do-not-remove
  :end-before: .. end-inclusion-usage-marker-do-not-remove

Step 3: Generate the files and directory structure
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

To generate the files and directory structure for your new project run the following command:

.. code-block:: bash

    cookiecutter https://gitlab.com/rwsdatalab/public/templates/rws-datalab-templates --directory templates/python

Step 4: Make a new library
^^^^^^^^^^^^^^^^^^^^^^^^^^

Fill in the form generated by the Cookiecutter template. You will be asked to supply the following information:

.. list-table::
   :header-rows: 1

   * - Name
     - Default value
     - Explanation
   * - project_name
     - python
     - Full project name. The package and distribution names are automatically derived from this. Ensure it starts with an alphabetical character and consists entirely of numbers, letters & spaces.
   * - project_short_description
     -
     - The information that you enter here will end up in the README, documentation, license, and pyproject.toml, so it may be a good idea to prepare something in advance
   * - version
     - 0.1.0
     - Package version
   * - gitlab_group
     - rwsdatalab
     - Gitlab repo path in the codebase. example: rwsdatalab/codebase/utils
   * - license
     - Not open source
     - The software license under which the code is made available
   * - author
     - RWS Datalab
     - Author of the software
   * - email
     - datalab.codebase@rws.nl
     - Contact email address
   * - copyright_holder
     - Rijkswaterstaat
     - Name(s) of the organization(s) or person(s) who hold the copyright of the software


In addition to the above properties, this Cookiecutter template also automatically generates *__project_slug* & *__package_name* properties for you. These are derived from *project_name* and PEP character requirements are enforced. Be sure to choose your project_name appropriately: `PEP 8 <https://www.python.org/dev/peps/pep-0008/#package-and-module-names>`_ - Style Guide for Python Code and `PEP 423 <https://www.python.org/dev/peps/pep-0423/>`_ - Naming conventions and recipes related to packaging. *__project_slug* represents the name of your Python package on GitLab (which uses "-" for spaces). *__package_name* represents the name of your Python package (which uses "_" for spaces).

See below an example of the dialog of the Python template (note that if you press enter the default option as shown in between brackets is used).

.. code-block:: bash

    $ cookiecutter https://gitlab.com/rwsdatalab/public/templates/rws-datalab-templates --directory templates/python
    #
    #   [1/8] project_name (python): rwsutils
    #   [2/8] project_short_description ():
    #   [3/8] version (0.1.0):
    #   [4/8] gitlab_group (rwsdatalab):
    #   [5/8] Select license
    #     1 - Not open source
    #     2 - Apache Software License 2.0
    #     3 - MIT license
    #     4 - BSD license
    #     5 - ISC license
    #     6 - GNU General Public License v3 or later
    #     Choose from [1/2/3/4/5/6] (1):
    #   [6/8] author (RWS Datalab):
    #   [7/8] email (datalab.codebase@rws.nl):
    #   [8/8] copyright_holder (Rijkswaterstaat):
    #
    # To finish setting up your project:
    #
    # - Navigate to your project directory.
    # - Install the required development packages.
    # - Initialize a Git repository.
    # - Install the Pre-commit hooks.
    # - Create your Git branches.
    # - Add all your files to the Git repository.
    # - Perform an initial commit.
    #
    # You could then proceed to add a remote and push it.
    # For example (you can directly copy these instructions):
    #
    # cd rwsutils
    # pip install '.[dev]'
    # git init
    # pre-commit install
    # git checkout -b main
    # git add .
    # git commit -m "Initial commit"
    #
    $ cd rwsutils
    $ ls
    # CHANGELOG.rst     MANIFEST.in  doc             requirements.txt
    # CONTRIBUTING.rst  NOTICE       pyproject.toml  setup.cfg
    # LICENSE           README.rst   python          tests

Step 5: Initialize the Gitlab repository
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

Unversioned code is out-of-control code: `Get your code under version control! <https://rwsdatalab.gitlab.io/guides/werkwijze/ontwikkelgids/algemeen/version_control.html>`_.


Step 6 (Python): Install pre-commit and other requirements
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

Now that the repository is initialized, you need to install pre-commit and other developer requirements. Pre-commit installs git hooks that help you to get your code into the expected standards.

.. code-block:: bash

    pip install '.[dev]'
    pre-commit install


The above steps need to be repeated when you perform a Git clone of an existing repository. Now all checks should run automatically whenever you commit something with Git. To run all checks manually you can do:

.. code-block:: bash

    pre-commit run --all-files


Next steps
""""""""""

* **Great! You've successfully created an empty project according to RWS Datalab standards.**


Other information (internal links):

* `Software development guide <https://rwsdatalab.gitlab.io/guides/software-development/guide/>`_
* `Creating a new repository <https://rwsdatalab.gitlab.io/guides/software-development/guide/gitlab/create_repository.html>`_
* `Repository settings & branches <https://rwsdatalab.gitlab.io/guides/software-development/guide/gitlab/repository_settings.html>`_
* `Adding badges to your project <https://rwsdatalab.gitlab.io/guides/software-development/guide/gitlab/badges.html>`_
